groups:
  - name: "Configuration"
    description: "Syncthing application configuration"
  - name: "Storage"
    description: "Configure storage for syncthing"
  - name: "Networking"
    description: "Networking Configuration for syncthing"
  - name: "Advanced DNS Settings"
    description: "Configure DNS settings"
  - name: "Resource Limits"
    description: "Set CPU/memory limits for Kubernetes Pod"

portals:
  web_portal:
    protocols:
      - "http"
    host:
      - "$node_ip"
    ports:
      - "$variable-web_port"
    path: "/"

questions:
  - variable: web_port
    label: "Web Port for syncthing"
    group: Networking
    schema:
      type: int
      min: 8000
      max: 65535
      default: 20910
      required: true
  - variable: tcp_port
    label: "TCP Port for syncthing"
    group: Networking
    schema:
      type: int
      min: 8000
      max: 65535
      default: 20978
      required: true
  - variable: udp_port
    label: "UDP Port for syncthing"
    group: Networking
    schema:
      type: int
      min: 8000
      max: 65535
      default: 20979
      required: true
  - variable: hostNetwork
    label: "Host Network"
    group: Networking
    schema:
      type: boolean
      default: false

  - variable: dnsConfig
    label: "DNS Configuration"
    group: "Advanced DNS Settings"
    schema:
      type: dict
      attrs:
        - variable: options
          label: "DNS Options"
          schema:
            type: list
            items:
              - variable: optionsEntry
                label: "Option Entry Configuration"
                schema:
                  type: dict
                  attrs:
                    - variable: name
                      label: "Option Name"
                      schema:
                        type: string
                        required: true
                    - variable: value
                      label: "Option Value"
                      schema:
                        type: string
                        required: true

  - variable: ownerUID
    label: "Owner User ID"
    group: Configuration
    schema:
      type: int
      default: 568
      min: 1
      max: 65535

  - variable: ownerGID
    label: "Owner Group ID"
    group: Configuration
    schema:
      type: int
      default: 568
      min: 1
      max: 65535

  - variable: environmentVariables
    label: "Syncthing environment"
    group: "Configuration"
    schema:
      type: list
      default: [ ]
      items:
        - variable: environmentVariable
          label: "Environment Variable"
          schema:
            type: dict
            attrs:
              - variable: name
                label: "Name"
                schema:
                  type: string
              - variable: value
                label: "Value"
                schema:
                  type: string

  - variable: appVolumeMounts
    label: "Syncthing Storage"
    group: "Storage"
    schema:
      type: dict
      attrs:
        - variable: config
          label: "Configuration Volume"
          schema:
            type: dict
            attrs:
              - variable: datasetName
                label: "Configuration Volume Dataset Name"
                schema:
                  type: string
                  hidden: true
                  $ref:
                    - "normalize/ixVolume"
                  show_if: [["hostPathEnabled", "=", false]]
                  default: "ix-syncthing_config"
                  editable: false
              - variable: mountPath
                label: "Configuration Mount Path"
                description: "Path where the volume will be mounted inside the pod"
                schema:
                  type: path
                  hidden: true
                  editable: true
                  default: "/var/syncthing"
              - variable: hostPathEnabled
                label: "Enable Custom Host Path for Syncthing Configuration Volume"
                schema:
                  type: boolean
                  default: false
                  show_subquestions_if: true
                  subquestions:
                    - variable: hostPath
                      label: "Host Path for Syncthing Configuration Volume"
                      schema:
                        type: hostpath
                        required: true
                        $ref:
                          - "validations/lockedHostPath"
  - variable: extraAppVolumeMounts
    label: "Extra Host Path Volumes"
    group: "Storage"
    schema:
      type: list
      items:
        - variable: extraAppVolume
          label: "Host Path Volume"
          description: "Add an extra host path volume for Syncthing application"
          schema:
            type: dict
            attrs:
              - variable: mountPath
                label: "Mount Path in Pod"
                description: "Path where the volume will be mounted inside the pod"
                schema:
                  type: path
                  required: true
              - variable: hostPath
                label: "Host Path"
                description: "Host path"
                schema:
                  type: hostpath
                  required: true
                  $ref:
                    - "validations/lockedHostPath"

  - variable: enableResourceLimits
    label: "Enable Pod resource limits"
    group: "Resource Limits"
    schema:
      type: boolean
      default: false
  - variable: cpuLimit
    label: "CPU Limresource limitsit"
    description: "CPU resource limit allow  plain integer values with suffix m(milli) e.g 1000m, 100."
    group: "Resource Limits"
    schema:
      type: string
      show_if: [["enableResourceLimits", "=", true]]
      valid_chars: "^\\d+(?:\\.\\d+(?!.*m$)|m?$)"
      default: "4000m"
  - variable: memLimit
    label: "Memory Limit"
    group: "Resource Limits"
    description: "Memory limits is specified by number of bytes. Followed by quantity suffix like E,P,T,G,M,k and Ei,Pi,Ti,Mi,Gi,Ki can also be used. e.g 129e6, 129M,  128974848000m, 123Mi"
    schema:
      type: string
      show_if: [["enableResourceLimits", "=", true]]
      valid_chars: "^([+-]?[0-9.]+)([eEinumkKMGTP]*[-+]?[0-9]*)$"
      default: "8Gi"

